<?php

require_once('blogger_common/common.php');

class api
{
	
	var $blogId_;
	
	// public,const
	function GetBlogId()
	{
		return $this->blogId_;
	}
	// public, const
	function GetBlogPath()
	{
		return 'blogger'.$this->blogId_;
	}
	
	// protected
	function GetIdByLogin($login)
	{
		
		$dir=opendir(dirname(__FILE__));
		
		$tmpUser=new BlogUser();
	
		while($file=readdir($dir))
		{
			
			if($file=='.'||$file=='..')
				continue;
			
			$str=strtoupper($file);
			if(!preg_match('/^blogger(\d+)$/i',$str,$matches))
				continue;	

			$tmpUser->Authorization('','',$str);
			
			if($tmpUser->GetNickname()==$login)
			{
				closedir($dir);
				return $matches[1];
			}
			
			
		}
		closedir($dir);
		
		return false;
		
	}
	
	// protected
	function FindBlog($login)
	{

		if(!$this->SetBlogByLogin($login))
		{
			echo GetXmlRpcFaultContent('User "'.$login.'" UNKNOWN',9910);
			exit;
		}
		
	}
	
	// protected, static
	function GetPath($id)
	{
		return "blogger$id";
	}
	
	// protected
	function SetBlog($id,$error=false)
	{
		
		if(!file_exists(dirname(__FILE__)."/blogger$id"))
		{
			if($error)
			{
				echo GetXmlRpcFaultContent('BlogID "'.$id.'" is invalid ',9903);
				exit;
			}
			else
				return false;
		}
		
		$this->blogId_=$id;
		require_once(dirname(__FILE__).'/'.$this->GetBlogPath().'/varsPersonal.php');
		
		global	$_dbOptions
			,	$_blogUser;
	
		$path=$this->GetPath($this->blogId_);
		$_dbOptions->ChangePath($path);
		$_blogUser->Authorization('','',$path);
		
		
		return true;

	}
	
	// protected
	function SetBlogByLogin($login)
	{
		return ($id=$this->GetIdByLogin($login))?$this->SetBlog($id):false;
	}
			

	
	function Result($blogId,$login,$password,$result,$error=array())
	{
		
		global	$_blogUser;
		
		if(count($error))
		{
			echo GetXmlRpcFaultContent($error['faultString'],$error['faultCode']);
			exit;
		}
		/*elseif($blogId&&$blogId!=BLOG_ID)
		{
			echo GetXmlRpcFaultContent('BlogID '.$blogId.' is invalid ',9903);
			exit;
		}*/
		elseif(!$_blogUser->Authorization($login,$password))
		{
			echo GetXmlRpcFaultContent('User authentication failed',4);
			exit;
		}
		
		return $result;
		
	}
	
	// public, static
	function GetBlogIdPostId($p)
	{
		$r=array();
		@list($r['blog'],$r['post'])=explode('/',$p);
		return $r;
	}
	// public, const
	function MakePostId($p)
	{
		return $this->GetBlogId()."/$p";
	}
	
	
}

class blogger extends api
{

	// private
	function GetTitle($body)
	{
		if(preg_match('/^\<title\>(.+)\<\/title\>(.+)$/',$body,$matches))
			return Array('title'=>$matches[1],'body'=>$matches[2]);
		else
			return Array('title'=>$body,'body'=>$body);

	}
	
	function newPost($paramZzz)
	{
		
		parent::SetBlog($paramZzz[1],true);
		
		global	$_blogUser;

		$result='';
		

		if($_blogUser->Authorization($paramZzz[2],$paramZzz[3],parent::GetBlogPath()))
		{
			
			require_once('blogger_common/post.php');

			$body=$this->GetTitle($paramZzz[4]);
			$result=AddBlogPost($body['title'],$body['body'],$paramZzz[5]=='1'?true:false);
		
			if($result==MOD_BLOGGER_ID_INVALID_POST)
				$error=array('faultString'=>'Unknown Error','faultCode'=>9904);
			else
			{
				$error=array();
				$result=parent::MakePostId($result);
			}

		}
		
		return parent::Result($paramZzz[1],$paramZzz[2],$paramZzz[3],strval($result),$error);
		
	}

	function editPost($paramZzz)
	{
		
		$ids=parent::GetBlogIdPostId($paramZzz[1]);
		
		parent::SetBlog($ids['blog'],true);

		global $_blogUser;

		$result=false;
		
		if($_blogUser->Authorization($paramZzz[2],$paramZzz[3]))
		{
			
			require_once('blogger_common/post.php');
		
			$body=$this->GetTitle($paramZzz[4]);
			
			$result=EditBlogPost(
				$ids['post'],
				$body['title'],
				$body['body'],
				$paramZzz[5]=='1'?true:false
			);
		}

		return parent::Result(0,$paramZzz[2],$paramZzz[3],$result);

	}

	function getUsersBlogs($paramZzz)
	{
		
		parent::FindBlog($paramZzz[1]);
		
		global $_blogUser;
		
		return parent::Result(
  			0,$paramZzz[1],$paramZzz[2],
   			array(
   				array('url'=>$_blogUser->GetUrl().'/blogger'.parent::GetBlogId().'/blog.php','blogid'=>parent::GetBlogId(),'blogName'=>$_blogUser->GetBlogName())
   			)
   		);

	}

	function getUserInfo()
	{
		
		parent::FindBlog($paramZzz[1]);
		
		global $_blogUser;

		return parent::Result(
			0,$paramZzz[1],$paramZzz[2],
				array($_blogUser->GetId(),$_blogUser->GetFirstname(),
						$_blogUser->GetLastname(),$_blogUser->GetNickname(),
						$_blogUser->GetEmail(),$_blogUser->GetUrl())
		);

	}


	// private
	function getPostInternal($post)
	{
		
		$r=array();

		$r['error']=!$post->IsValid()
			?	array('faultString'=>'postId invalid','faultCode'=>9905)
			:	array();

		$date=$post->GetDateISO8601();
		xmlrpc_set_type(/*&*/$date,"datetime");

		$r['result']=array(
			'userId'=>$post->GetAuthor(),
			'content'=>'<title>'.$post->GetTitle().'</title>'.$post->GetBody(),
			'dateCreated'=>$date,
			'postid'=>parent::MakePostId($post->GetID())
		);
		
		return $r;

	}


	function getPost($paramZzz)
	{
		
		$ids=parent::GetBlogIdPostId($paramZzz[1]);
		
		parent::SetBlog($ids['blog'],true);
		
		require_once('blogger_common/post.php');

		$post=new Post($ids['post']);

		$data=$this->getPostInternal($post);
		$error=$data['error'];
		$result=$data['result'];

		return parent::Result(0,$paramZzz[2],$paramZzz[3],$result,$error);

	}

	function getRecentPosts($paramZzz)
	{
		
		parent::SetBlog($paramZzz[1],true);
		
		require_once('blogger_common/post.php');

		$post=new Post(MOD_BLOGGER_ID_LAST_POST);
		$id=$post->GetID();
		
		$error=array();
		$result=array();

		for($i=0;$post->IsValid()&&!sizeof($error)&&$id>=1&&$i<$paramZzz[4];)
		{
			if(!$post->IsComment())
			{
				$i++;
				$data=$this->getPostInternal($post);
				$error=$data['error'];
				array_push($result,$data['result']);
			}
			$id=$post->GetID();
			$post->Load(--$id,true);
		}
			
		return parent::Result($paramZzz[1],$paramZzz[2],$paramZzz[3],$result,$error);

	}

	function deletePost($paramZzz)
	{
		
		$ids=parent::GetBlogIdPostId($paramZzz[1]);
		
		parent::SetBlog($ids['blog'],true);
		
		require_once('blogger_common/post.php');

		global $_blogUser;
		if($_blogUser->Authorization($paramZzz[2],$paramZzz[3]))
			DeleteBlogPost($ids['post']);
		return parent::Result(0,$paramZzz[2],$paramZzz[3],true);

	}

	function getTemplate($null)
    {
		echo GetXmlRpcFaultContent('Templates NOT enabled',9910);
		exit;
	}

	function setTemplate($null)
    {
		echo GetXmlRpcFaultContent('Templates NOT enabled',9910);
		exit;
	}
	

}


function XmlRpc()
{

	global $HTTP_RAW_POST_DATA;

	if(!function_exists('xmlrpc_server_create'))
	{
		echo GetXmlRpcFaultContent('XML-RPC support NOT enabled in PHP installation',1005);
		exit;
	}

	if(!$server=xmlrpc_server_create())
	{
		echo GetXmlRpcFaultContent('XML-RPC server not enabled',99001);
		exit;
	}
	
	$null=xmlrpc_decode_request($HTTP_RAW_POST_DATA,/*&*/$xmlRpcMethod);
	@list($class,$method)=explode('.',$xmlRpcMethod);

	if(!class_exists($class))
	{
		xmlrpc_server_destroy($server);
		echo GetXmlRpcFaultContent('XML-RPC class has not been defined',99002);
		exit;
	}

	eval('$GLOBALS["_$class"]=new '."$class;");

	if(		method_exists($GLOBALS["_$class"],$method)
		&&	xmlrpc_server_register_method($server,$xmlRpcMethod,'XmlRpcCaller'))
	{	
		$null=xmlrpc_server_call_method($server,$HTTP_RAW_POST_DATA,'');
		//fwrite(fopen('xmlrpc_result.dump','w'),$null);
		echo $null;
	}
	
	xmlrpc_server_destroy($server);
	
	exit;

}

function GetXmlRpcFaultContent($string,$code)
{

	$result=	"\n";
	$result.=	"<methodResponse>\n";
	$result.=	"<fault>\n";
	$result.=	" <value>\n";
	$result.=	"  <struct>\n";
	$result.=	"   <member>\n";
	$result.=	"    <name>faultString</name>\n";
	$result.=	"    <value>\n";
	$result.=	"     <string>$string</string>\n";
	$result.=	"    </value>\n";
	$result.=	"   </member>\n";
	$result.=	"   <member>\n";
	$result.=	"    <name>faultCode</name>\n";
	$result.=	"    <value>\n";
	$result.=	"     <int>$code</int>\n";
	$result.=	"    </value>\n";
	$result.=	"   </member>\n";
	$result.=	"  </struct>\n";
	$result.=	" </value>\n";
	$result.=	"</fault>\n";
	$result.=	"</methodResponse>\n";
	
	return $result;
			
}

function XmlRpcCaller($xmlRpcMethod,$paramZzz)
{
	@list($class,$method)=explode('.',$xmlRpcMethod);
	eval("\$result=\$GLOBALS[\"_$class\"]->$method(\$paramZzz);");
	return $result;
}

XmlRpc();



?>
