<?php
// ------------------------------------------------------------
//   Site Builder (c) 2004-2005, SWsoft
//
//
// version: $Id: filesAPI.php,v 1.7 2006/03/17 09:32:18 epalchukovsky Exp $
//  author: Evgene V. Palchukovsky
// ------------------------------------------------------------


if(!function_exists('dio_open')):

	define('F_SETLKW',1);
	define('O_CREAT',2);
	define('O_RDWR',4);
	define('O_TRUNC',8);

	function dio_open($f,$m)
	{

		$mode=$m&O_TRUNC
			?	'w+'
			:	'a+';
		$f=fopen($f,$mode);
		fseek($f,0,SEEK_SET);
		return $f;
	}

	function dio_close($h)
	{
		fclose($h);
	}

	function dio_fcntl($h,$cmd,$parmZZZ)
	{
		flock($h,2);
	}

	function dio_stat($h)
	{
		return fstat($h);
	}

	function dio_read($h,$l)
	{
		return fread($h,$l);
	}

	function dio_seek($h,$o,$m)
	{
		return fseek($h,$o,$m);
	}

	function dio_truncate($h,$l)
	{
		return ftruncate($h,$l);
	}

	function dio_write($h,$d)
	{
		return fwrite($h,$d);
	}

endif;

$GLOBALS['_staticBuffer']=NULL;


class MainStorage
{

	var	$m_pos;

	function Load(&$db)
	{
		$datap=$db['data'][$db['index']];
		$datap['id']=$db['index'];
		$this->CloseDBHandle($db);
		$datap['body']	='';//$this->GetBodyContent(); - see the GetBody method;

		return $datap;
	}


	// private, static
	function CreateDb()
	{

		global	$_blogUser;

		$dir=$_blogUser->GetPathUser().MOD_BLOGGER_DB_PATH;
		if(!file_exists($dir))
		{
			$dirData=$_blogUser->GetPathUser().MOD_DB_PATH;
			if(!file_exists($dirData))
			{
				mkdir($dirData);
				chmod($dirData,0777);
			}
			mkdir($dir);
			chmod($dir,0777);

			if(file_exists($_blogUser->GetPathUser().'filedb'))
				$this->MigrateTo1_1_0();

		}

	}

	// private, static
	function GetDBHandle($table,$error=true)
	{

		if(		$GLOBALS['_staticBuffer']!==NULL
			&&	isset($GLOBALS['_staticBuffer'][$table])
			&&	$GLOBALS['_staticBuffer'][$table]!==NULL)
		{
			return $GLOBALS['_staticBuffer'][$table];
		}

		global	$_blogUser;

		$this->CreateDb();

		$file=array();
		$filePath=$_blogUser->GetPathUser().MOD_BLOGGER_DB_PATH.$table;
		$fe = is_file($filePath);
		$file['handle']=dio_open($filePath,O_RDWR|O_CREAT,0100666);
		if (!$fe) {
			chmod($filePath, 0666); // Bug 58794
		}

		if(!$file['handle'])
		{

			if($error)
				$this->Log('Unable to open file '.$_blogUser->GetPathUser().MOD_BLOGGER_DB_PATH.$table);

			$file=NULL;

		}
		else
		{

			$file['table']=$table;
			$file['modifed']=false;

			dio_fcntl($file['handle'],F_SETLKW,array('read lock','write lock'));

			$stat=dio_stat($file['handle']);
			$file['data']=$stat['size']
				?	unserialize(dio_read($file['handle'],$stat['size']))
				:	array();

		}

		return $file;

	}

	// private, static
	function CloseDBHandle(&$file)
	{

		if($file['modifed'])
		{

			dio_seek($file['handle'],0,SEEK_SET);
			dio_truncate($file['handle'],0);
			dio_write($file['handle'],serialize($file['data']));
			@dio_close($file['handle']);

			$GLOBALS['_staticBuffer'][$file['table']]=NULL;

		}
		else
			$GLOBALS['_staticBuffer'][$file['table']]=$file;

		$file=NULL;

	}

	function MigrateTo1_1_0()
	{

		global $_blogUser;

		$source=$_blogUser->GetPathUser().'filedb';

		$distination=$_blogUser->GetPathUser().MOD_BLOGGER_DB_PATH;
		$dir = opendir($source);
		while($file = readdir($dir))
		{

			if($file == '.' || $file == '..')
				continue;

			$currSource=$source.'/'.$file;
			$currDist=$distination.'/'.$file;

			if(is_file($currSource) && !is_dir($currSource))
			{
				$perms = fileperms($currSource);
				copy($currSource, $currDist);
				chmod($currDist, $perms);
				touch ($currDist);
				unlink($currSource);
			}

		}

		closedir($dir);

		@rmdir($source);

	}

	// private, const
	function FindIndexRecord($notEq=false)
	{

		if(!($db=$this->GetDBHandle(MOD_BLOGGER_DB_POSTS)))
			return false;

		if(isset($db['data'][$this->post_]))
		{
			$db['index']=$this->post_;
			return $db;
		}
		elseif($notEq)
		{

			$index=$this->post_-1;
			while(!isset($db['data'][$index])&&$index--);

			if($index>=0)
			{
				$db['index']=$index;
				return $db;
			}

		}

		$this->CloseDBHandle($db);

		return false;

	}


	// protected, const
	function GetBodyContent()
	{
		global	$_blogUser;
		$body='';
		$file=$_blogUser->GetPathUser().MOD_BLOGGER_DB_PATH.$this->post_.'.txt';
		if(file_exists($file))
			$body=file_get_contents($file);
		return $body;
	}

	// protected, static
	function SaveMainFields(&$db,$id,$publish,$comment,$time,$author,$title)
	{

		if($id===NULL)
			$id=$this->GetNextID($db);

		$db['data'][$id]=array(
			'publish'	=>$publish,
			'comment'	=>$comment,
			'time'		=>$time,
			'author'	=>$author,
			'title'		=>$title
		);

		$db['modifed']=true;

		return $id;

	}

	// private, static
	function SaveBody($id,$bodyContent)
	{

		$filePath=$GLOBALS['_blogUser']->GetPathUser().MOD_BLOGGER_DB_PATH.$id.'.txt';
		$f=dio_open($filePath,O_RDWR|O_CREAT|O_TRUNC,0100666);
		dio_write($f,$bodyContent);
		dio_close($f);
		chmod($filePath,0666); // Bug 58794

		//fopen($GLOBALS['_blogUser']->GetPathUser().MOD_BLOGGER_DB_PATH.$id.'.txt','w');
		//fwrite($f,$bodyContent);
		//fclose($f);

		return true;

	}

	function GetLastID(&$db)
	{
		if(!is_array($db['data'])||sizeof($db['data'])==0)
		{
			return 0;
		}
		else
		{

			krsort($db['data']);
			reset($db['data']);

			$r=each($db['data']);

			return $r['key'];

		}

	}

	function GetNextID(&$db)
	{
		$id=$this->GetLastID($db);
		return ++$id;
	}


	function FillCommentsArray(&$db)
	{

		return isset($db['data'][$this->post_])
			?	$db['data'][$this->post_]
			:	array();

	}

	function InsertComments(&$db,$comments)
	{
		$db['data'][$this->GetId()]=$comments;
		$db['modifed']=true;
	}

	function DeleteComments(&$db)
	{

		if(!$this->comment_)
		{
			unset($db['data'][$this->post_]);
			$db['modifed']=true;
		}

	}

	// private
	function DeletePost(&$db,$id,&$cdb)
	{

		unset($db['data'][$id]);
		$db['modifed']=true;

		foreach($cdb['data'] as $key=>$val)
		{
			$s=array_search($id,$val);
			if($s!==false)
				unset($cdb['data'][$key][$s]);
		}

		unset($cdb['data'][$id]);

		$cdb['modifed']=true;

		unlink($GLOBALS['_blogUser']->GetPathUser().MOD_BLOGGER_DB_PATH.$id.'.txt');


	}

	function Delete(&$db)
	{

		if(!($cdb=$this->GetDBHandle(MOD_BLOGGER_DB_COMMENTS)))
			return;

		$this->DeleteComments($cdb);
		$this->CloseDBHandle($cdb);
		$cdb=$this->GetDBHandle(MOD_BLOGGER_DB_COMMENTS);

		foreach($this->comments_ as $id)
			$this->DeletePost($db,$id,$cdb);

		$this->DeletePost($db,$this->post_,$cdb);

		$this->CloseDBHandle($cdb);

	}

	function CheckEx()
	{
		return true;
	}

	function GetExName()
	{
		return 'filesystem';
	}

}
?>
