<?php

global $_dbOptions;

if(!$_dbOptions->IsValid())
	die(MOD_BLOGGER_DB_OPTIONS.' fail');
else
	require_once($_dbOptions->GetDBSourceModule());

class Post extends MainStorage // SQLiteStorage //FileStorage
{

	var	$post_;

	var	$author_
	,	$title_
	,	$body_
	,	$time_
	,	$publish_
	,	$comment_
	,	$comments_=array();

	function Post(	$post=MOD_BLOGGER_ID_NEW_POST
				,	$author=null
				,	$title=null
				,	$body=null
				,	$firstComment=MOD_BLOGGER_ID_INVALID_POST)
	{
		
		if(!$this->CheckEx())
		{
			echo	'<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"><html><head>'
				.	'<title>Error</title>'
				.	'<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>'
				.	'<link rel="stylesheet" href="blogger.css" type="text/css"/>'
				.	'</head>'
				.	'<body><div style="font-family: Tahoma, Verdana, Arial, Helvetica, sans-serif; font-weight: bold; font-size: normal;">'
				.	sprintf(LOC_DB_EXT_ERROR,$this->GetExName())
				.	'</div></body>'
				.	'</html>';
			exit(0);
			return;
		}

		$this->Load($post);

		if($author!==null)
			$this->SetAuthor($author);
		if($title!==null)
			$this->SetTitle($title);
		if($body!==null)
			$this->SetBody($body);
			
		if($firstComment!=MOD_BLOGGER_ID_INVALID_POST)
			$this->AddComment($firstComment);
			
	}

	// private
	function Init(	$author=''
				,	$title=''
				,	$body=''
				,	$publish=true
				,	$comment=false
				,	$time=0)
	{

		$this->author_	=$author;

		$this->title_	=$title;
		$this->body_	=$body;

		$this->publish_	=$publish;
		$this->comment_	=$comment;

		$this->time_	=$time?$time:time();

	}

	// public
	function Load($post=MOD_BLOGGER_ID_NEW_POST,$notEq=false)
	{
		if($post==MOD_BLOGGER_ID_NEW_POST)
		{
			$this->post_=MOD_BLOGGER_ID_NEW_POST;
			$this->Init();
			$comments_=array();
			return true;
		}
		else if($post==MOD_BLOGGER_ID_LAST_POST)
		{
			if($db=parent::GetDBHandle(MOD_BLOGGER_DB_POSTS))
			{
				$id=parent::GetLastID($db);
				parent::CloseDBHandle($db);
				return $this->Load($id);
			}
			
		}
		else if($post>0)
		{
			$this->post_=$post;
			if($db=parent::FindIndexRecord($notEq,true))
			{
				$data=parent::Load($db);
				$this->post_=$data['id'];
				$this->Init(
					$data['author'],$data['title'],$data['body'],
					$data['publish'],$data['comment'],$data['time']
				);
				$this->LoadComments();
				return true;
			}
		}

		$this->post_=MOD_BLOGGER_ID_INVALID_POST;
		$this->Init();
		return false;

	}
	
	// private
	function LoadComments()
	{
		
		if($db=parent::GetDBHandle(MOD_BLOGGER_DB_COMMENTS))
		{
			$this->comments_=parent::FillCommentsArray($db);
			parent::CloseDBHandle($db);
		}
		else
			$this->comments_=array();

	}

	// public
	function SetAuthor($str)
	{

		$str=trim($str);

		if(strlen($str)>(MOD_BLOGGER_FIELD_AUTHOR_LENGTH*2))
			$str=substr($str,0,MOD_BLOGGER_FIELD_AUTHOR_LENGTH*2).'...';

		$this->author_=$str;

	}
	function SetTitle($str)
	{

		$str=trim($str);
		
		if(strlen($str)>(MOD_BLOGGER_FIELD_TITLE_LENGTH*2))
			$str=substr($str,0,(MOD_BLOGGER_FIELD_TITLE_LENGTH*2)).'...';

		$this->title_=$str;

	}
	function SetBody($str)
	{
		$this->body_=trim($str);
	}
	

	// public
	function IsValid()
	{
		return $this->post_!=MOD_BLOGGER_ID_INVALID_POST;
	}

	function IsPublished()
	{
		return $this->publish_;
	}
	
	function IsComment()
	{
		return $this->comment_;
	}

	// public, const
	function GetID()
	{
		return $this->post_;
	}

	// public
	function GetAuthor()
	{
		return $this->author_;
	}

	// public
	function GetTitle()
	{
		return $this->title_;
	}

	// public
	function GetBody()
	{
	
		if(empty($this->body_))
			 $this->body_=parent::GetBodyContent();

		return $this->body_;

	}

	// public
	function GetDateISO8601()
	{
		return date('Ymd\TH:i:s',$this->time_);
	}
	
	// public
	function GetDateString()
	{
		return date('H:i:s d.m.Y',$this->time_);
	}


	// private, const
	function SaveMainFields(&$db,$publish,$comment=false)
	{

		$this->publish_=$publish;
		$this->comment_=$comment;
		$res=parent::SaveMainFields($db,$this->post_,$this->publish_,$this->comment_,$this->time_,$this->author_,$this->title_);
		if($res!=false)
		{
			$this->post_=$res;
			return true;
		}
		else
		{
			$this->post_=MOD_BLOGGER_ID_INVALID_POST;
			return false;
		}
		

	}
	// private, const
	function SaveBody()
	{
		return parent::SaveBody($this->post_,$this->GetBody());
	}

	// public 
	function Update($publish)
	{
		
		if(!$db=parent::FindIndexRecord())
			return false;

		$error=false;
		
		if(!$this->SaveMainFields($db,$publish,$this->comment_))
		{
			parent::CloseDBHandle($db);
			$this->Log('Write error '.MOD_BLOGGER_DB_POSTS);
			$error=true;
		}

		if(!$error&&!$this->SaveBody())
		{
			$this->Log('Write error (body) '.MOD_BLOGGER_DB_PATH.$this->post_.'.txt');
			$error=true;
		}
		
		if(!$error&&$cdb=parent::GetDBHandle(MOD_BLOGGER_DB_COMMENTS))
		{
			parent::DeleteComments($cdb);
			parent::InsertComments($cdb,$this->comments_);
			parent::CloseDBHandle($cdb);
		}
		else
			$error=true;
			
		parent::CloseDBHandle($db);

		return !$error;

	}
	
	// public
	function Insert($publish,$comment=false)
	{

		if(		!$this->IsValid()
			||	!($db=parent::GetDBHandle(MOD_BLOGGER_DB_POSTS)))
		{
			return $this->post_=MOD_BLOGGER_ID_INVALID_POST;
		}

		////////////////////////////////////////////////

		$this->post_=null;

		if(!$this->SaveMainFields($db,$publish,$comment))
		{
			parent::CloseDBHandle($db);
			$this->Log('Write error '.MOD_BLOGGER_DB_POSTS);
			return $this->post_=MOD_BLOGGER_ID_INVALID_POST;
		}

		if(!$this->SaveBody())
		{

			parent::CloseDBHandle($db);
			
			$this->Delete();
			
			$this->Log('Write error (body) '.MOD_BLOGGER_DB_PATH.$this->post_);
			return $this->post_=MOD_BLOGGER_ID_INVALID_POST;

		}

		////////////////////////////////////////////////
		
		global	$_dbOptions;

		if($_dbOptions->GetDBSourceModuleId()=='files')
		{
			$cdb=parent::GetDBHandle(MOD_BLOGGER_DB_COMMENTS);
		}
		else
			$cdb=$db;

		if($cdb)
		{
			parent::InsertComments($cdb,$this->comments_);
			if($_dbOptions->GetDBSourceModuleId()=='files')
				parent::CloseDBHandle($cdb);
			parent::CloseDBHandle($db);
			return $this->post_;
		}
		else
		{
			parent::CloseDBHandle($db);
			$this->Delete();
			return MOD_BLOGGER_ID_INVALID_POST;
		}

	}

	// public
	function Delete()
	{

		if(		!$this->IsValid()
			||	!($db=parent::GetDBHandle(MOD_BLOGGER_DB_POSTS)))
		{
			return;
		}
		
		parent::Delete($db);
		parent::CloseDBHandle($db);

		$this->post_=MOD_BLOGGER_ID_INVALID_POST;

	}

	// protected, static
	function Log($message)
	{

		if(!($file=fopen(MOD_BLOGGER_ERRORLOG,'a')))
			exit($message);
		else
		{
			fwrite($file,time()." Post $message\n");
			fclose($file);
		}

	}
	
	function GetCommentsCount()
	{
		return count($this->comments_);
	}

	// public
	function GetCommentsIDsArray()
	{
		return $this->comments_;
	}

	// public
	function AddComment($comment)
	{
		array_push($this->comments_,$comment);
	}

}


function cutVords($str)
{
	return wordwrap($str,40,' ',1);
}

function AddBlogPost($title,$body,$publish)
{
		
	global	$_blogUser;
	
	if(!$_blogUser->IsAuthorized())
		return MOD_BLOGGER_ID_INVALID_POST;
		
	$title=		CheckString($title);
	$body=		CheckString(cutVords($body));
	
	$post=new Post(MOD_BLOGGER_ID_NEW_POST,$_blogUser->GetNickname(),$title,$body);
	return $post->Insert($publish);
	
}
function AddComment($author,$title,$body,$parent)
{
	
	$author=	CheckString($author);
	$title=		CheckString($title);
	$body=		CheckString(cutVords($body));
	
	$c=new Post(MOD_BLOGGER_ID_NEW_POST,$author,$title,$body);
	if($c->Insert(false,true)==MOD_BLOGGER_ID_INVALID_POST)
		return false;
	
	$post=new Post();
	$post->Load($parent);
	if($post->IsValid())
	{
		$post->AddComment($c->GetID());
		if(!$post->Update($post->IsPublished()))
		{
			$c->Delete();
			return false;
		}
	}
	else
	{
		$c->Delete();
		return false;
	}

	return true;

}
function EditBlogPost($id,$title,$body,$publish,$author='')
{
	
	global	$_blogUser;
	
	if(!$_blogUser->IsAuthorized())
		return false;
		
	$title=		CheckString($title);
	$body=		CheckString(cutVords($body));
	
	$post=new Post(
		$id,
		empty($author)?$_blogUser->GetNickname():$author,
		$title,
		$body);
	return $post->Update($publish);
}
function DeleteBlogPost($id)
{
	global	$_blogUser;
	if(!$_blogUser->IsAuthorized())
		return;
	$post=new Post($id);
	$post->Delete();
}


?>